## cmocka-extensions 0.50.0

=== CMakeLists.txt ===
# SPDX-License-Identifier: MIT
cmake_minimum_required(VERSION 3.21)
include(cmake/project.cmake)
project(cmocka_extensions LANGUAGES C VERSION ${CMOCKA_EXTENSIONS_VERSION})

list(APPEND CMAKE_PREFIX_PATH "${INSTALL_DIR}/usr/local/lib/cmake")

project_set_environment()
project_set_version_variables()
project_add_documentation_target(
  TITLE
    "BaseOS Cmocka_extensions Documentation"
  MARKDOWN
    ${CMAKE_SOURCE_DIR}/documentation/documentation.md
)

add_subdirectory(src)
add_subdirectory(examples)

if(PACKAGING)
  include(cmake/Packing.cmake)
endif(PACKAGING)

=== examples/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
cmake_minimum_required(VERSION 3.16)

project(examples LANGUAGES C)

set(INSTALL_UNIT_TESTS OFF)

add_subdirectory(src)
add_subdirectory(test/utest)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
add_subdirectory(cmocka_extensions)

=== examples/src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
include(weak_library.cmake)

add_subdirectory(self_referencing)
add_subdirectory(extref_library)
add_subdirectory(extref_dependency)

=== src/cmocka_extensions/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

add_library(
  cmocka_extensions INTERFACE
)

set_property(TARGET cmocka_extensions PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(cmocka_extensions
  INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  $<INSTALL_INTERFACE:include/>
)

target_link_libraries(
  cmocka_extensions
  INTERFACE
    cmocka
)

install(
  EXPORT cmocka_extensionsTargets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_extensions
  NAMESPACE cmocka_extensions::
  FILE cmocka_extensionsTargets.cmake # Not sure if this is still needed
)

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "Config.cmake.in"
  "cmocka_extensionsConfig.cmake"
  INSTALL_DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_extensions
  PATH_VARS
    CMAKE_INSTALL_LIBDIR
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/cmocka_extensionsConfigVersion.cmake
  VERSION ${PKG_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/cmocka_extensionsConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/cmocka_extensionsConfigVersion.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_extensions"
)

install(TARGETS cmocka_extensions EXPORT cmocka_extensionsTargets  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== examples/src/extref_dependency/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

add_library(
  extref_dependency SHARED
  dependency.c
)
add_library(
	extref_dependency_static STATIC
  dependency.c
)

set_property(TARGET extref_dependency PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET extref_dependency_static PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(extref_dependency
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
	$<INSTALL_INTERFACE:include/>
)
target_include_directories(extref_dependency_static
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
	$<INSTALL_INTERFACE:include/>
)
create_weak_library(FROM extref_dependency_static)

=== examples/src/extref_library/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

add_library(
  extref_library SHARED
  library.c
)
add_library(
	extref_library_static STATIC
  library.c
)


set_property(TARGET extref_library PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET extref_library_static PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(extref_library
  PUBLIC
	$<TARGET_PROPERTY:extref_dependency,INTERFACE_INCLUDE_DIRECTORIES>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
	$<INSTALL_INTERFACE:include/>
)
target_include_directories(extref_library_static
  PUBLIC
	$<TARGET_PROPERTY:extref_dependency_static,INTERFACE_INCLUDE_DIRECTORIES>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
	$<INSTALL_INTERFACE:include/>
)

=== examples/src/self_referencing/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

add_library(
  selfref SHARED
	selfref.c
)
add_library(
	selfref_static STATIC
	selfref.c
)
set_property(TARGET selfref PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET selfref_static PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(selfref
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  $<INSTALL_INTERFACE:include/>
)
target_include_directories(selfref_static
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  $<INSTALL_INTERFACE:include/>
)

create_weak_library(FROM selfref_static)

=== examples/test/utest/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
include(unit_test.cmake)

add_subdirectory(mocks)
add_subdirectory(selfref)
add_subdirectory(extref)

=== examples/test/utest/extref/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
add_subdirectory(weak)
add_subdirectory(wrap)

=== examples/test/utest/mocks/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
include(create_mock_lib.cmake)

add_subdirectory(extref_dependency)
add_subdirectory(selfref)

=== examples/test/utest/selfref/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
create_unit_test(
  NAME
		weak_selfref_example
  SOURCES
    example.c
  LIBRARIES
    mock_selfref_static # important must come befor selfref_static_weak to work
    selfref_static_weak
)

=== debian/changelog ===
cmocka-extensions (0.50.0-0ubuntu1) oracular; urgency=medium

  * First upload to Ubuntu. Note that this package has a packaging
    history with upstream using Debian revisions, and in PPAs sometimes
    using Ubuntu revisions, in preparation of this upload. Since there
    is no ambition to distribute debs from upstream or even in Debian in
    the short-term, I'm resetting to the most logical first Ubuntu
    revision for that upstream release. I'm preserving past PPA and
    upstream revisions in the changelog for clarity of what this is
    based on.

 -- Loïc Minier <loic.minier@ubuntu.com>  Thu, 27 Jun 2024 13:07:50 +0000

cmocka-extensions (0.50.0-7ubuntu2~ppa0) oracular; urgency=medium

  * Add lintian override justification.
  * Reference upstream issue for git dependency.
  * Build documentation package only for indep.

 -- Alexandre Esse <alexandre.esse@canonical.com>  Mon, 24 Jun 2024 16:29:50 +0200

cmocka-extensions (0.50.0-7ubuntu1) oracular; urgency=medium

  * Initial release (LP: #2069860).
  * Update maintainer to Ubuntu Developers.
  * Remove control vcs fields as they might be unvalid once into Ubuntu.
  * Set cmocka-extensions-doc section to doc.
    To fix lintian wrong-section-according-to-package-name info message.
  * Set cmocka-extensions section to devel.
    To be consistent with cmocka package section.
  * Use debian/clean path list to be deleted.
  * Set documentation build dependencies as Build-Depends-Indep.
  * Develop the packages descriptions to advertise for packages features.

 -- Alexandre Esse <alexandre.esse@canonical.com>  Thu, 20 Jun 2024 08:42:15 +0200

cmocka-extensions (0.50.0-7) unstable; urgency=medium

  * Add cmocka-extensions-doc.lintian-overrides to override a
    zero-byte-file-in-doc-directory warning.

 -- Isaac True <isaac.true@emlix.com>  Mon, 13 May 2024 16:27:10 +0200

cmocka-extensions (0.50.0-6) unstable; urgency=medium

  * Clean up generated documentation before building.
  * Do not ship platuml source files.

 -- Isaac True <isaac.true@emlix.com>  Wed, 08 May 2024 14:57:27 +0200

cmocka-extensions (0.50.0-5) unstable; urgency=medium

  * Build docs before packaging.
  * Do not compress markdown files.
  * Remove unnecessary shlibs dependencies.
  * Add the following build dependencies:
     - pandoc
     - pandoc-plantuml-filter
     - graphviz

 -- Isaac True <isaac.true@emlix.com>  Wed, 08 May 2024 12:11:33 +0200

cmocka-extensions (0.50.0-4) unstable; urgency=medium

  * Update gbp.conf with the new branch names.

 -- Isaac True <isaac.true@emlix.com>  Tue, 07 May 2024 15:42:18 +0200

cmocka-extensions (0.50.0-3) unstable; urgency=medium

  * Add libcmocka-dev to cmocka-extensions-dev dependencies.

 -- Isaac True <isaac.true@emlix.com>  Tue, 07 May 2024 14:40:09 +0200

cmocka-extensions (0.50.0-2) unstable; urgency=medium

  * Add gbp.conf

 -- Isaac True <isaac.true@emlix.com>  Tue, 07 May 2024 12:04:01 +0200

cmocka-extensions (0.50.0-1) unstable; urgency=medium

  * Initial release.

 -- Isaac True <isaac.true@emlix.com>  Tue, 07 May 2024 11:25:20 +0200

=== debian/control ===
Source: cmocka-extensions
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Isaac True <isaac.true@emlix.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libcmocka-dev,
# related issue: https://github.com/Elektrobit/cmocka_extensions/issues/5
 git,
Build-Depends-Indep:
 pandoc,
 pandoc-plantuml-filter,
 graphviz,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/Elektrobit/cmocka_extensions

Package: cmocka-extensions-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcmocka-dev,
Description: Collection of mocking related code extensions for cmocka
 Mocking related code extensions for cmocka used by elos and other projects.
 .
 This package extends basic cmocka features and intoduces:
  - weak mocking
  - wrap mocking
  - and some definitions to make creating and running the unit tests a bit
    easier that the basic cmocka

Package: cmocka-extensions-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Description: Documentation for mocking related code extensions for cmocka
 Mocking related code extensions for cmocka used by elos and other projects.
 .
 This package extends basic cmocka features and intoduces:
  - weak mocking
  - wrap mocking
  - and some definitions to make creating and running the unit tests a bit
    easier that the basic cmocka
 .
 This is the associated documentation package.

=== debian/rules ===
#!/usr/bin/make -f

# LTO needs to be disabled for the tests to work
# related issue: https://github.com/Elektrobit/cmocka_extensions/issues/1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

override_dh_auto_build-arch:
	dh_auto_build -- all

override_dh_auto_build-indep:
	dh_auto_build -- all cmocka_extensions_doc

override_dh_install:
	dh_install
	# Do not ship plantuml source files
	find debian/ -name \*.plantuml -delete

override_dh_compress:
	# Do not compress .md files
	dh_compress --exclude=.md

=== debian/watch ===
version=4
https://github.com/Elektrobit/cmocka_extensions/tags .*/cmocka_extensions-(\d+).(\d+).(\d+).tar.gz
